import { BuildAppProps } from '@cloudbase/lowcode-generator';
import { IPlatformApp } from '@cloudbase/cals';
import { ICDN_ENDPOINTS_COFIG } from '../config';
import { BuildType } from '../types/common';
import { ICommonBuildContext } from '../mp/BuildContext';
/**
 * 该函数从 @govcloud/generate 取到需要的模版文件
 */
export declare function generateProjectFiles(buildData: BuildAppProps): Promise<void>;
export declare function generateHTML({ buildContext, appId, envId, description, appBuildDir, externalResources, mode, devTool, isBuildApp, buildTypeList, cdnEndpoints, 
/**
 * 由于存量兜底逻辑存在
 * 默认值为 undefined 否则应为 false
 */
enableLoading, publicPath, }: {
    buildContext: Pick<ICommonBuildContext, 'materialLibs' | 'uin'>;
    appId: string;
    envId: string;
    description?: string;
    externalResources: Required<IPlatformApp>['externalResources'];
    appBuildDir: string;
    mode: string;
    devTool: string;
    isBuildApp: boolean;
    buildTypeList: BuildType[];
    cdnEndpoints?: ICDN_ENDPOINTS_COFIG;
    enableLoading?: boolean;
    publicPath?: string;
}): Promise<void>;
export declare function handleAssets({ appBuildDir, buildTypeList, assets, }: {
    appBuildDir: string;
    buildTypeList: string[];
    assets: string;
}): Promise<string[]>;
export declare function generateThemeVarsFile(themeVars: object | undefined, appBuildDir: string): Promise<void>;
