import { IWeAppData, IPlugin, CSSProperties } from '@cloudbase/lowcode-generator/lib/weapps-core';
import { ICDN_ENDPOINTS_COFIG } from '../config';
import { IBuildContext, IMpCommonBuildContext } from './BuildContext';
import { BuildType } from '../types/common';
import { IPlatformApp } from '@cloudbase/cals';
import { IBuildWedaApp } from '../core';
export declare function generateWedaRootCommonFile({ buildContext, buildTypeList, localWedaRoot, loginConfigVersion, cssVarMap, appId, filter, }: {
    buildContext: IMpCommonBuildContext & Partial<Pick<IBuildContext, 'enableExpiredTag' | 'domain' | 'runtimeDynamicConfig'>>;
    buildTypeList: BuildType[];
    localWedaRoot: string;
    appId?: string;
    loginConfigVersion?: string;
    cssVarMap?: Object;
    filter?: (src: string) => boolean;
}): Promise<void>;
export declare function generateWxMp({ buildContext: _buildContext, weapps, calses, deployOptions, options, buildTypeList, ignoreInstall, cdnEndpoints, mpConfig, }: {
    buildContext: Omit<IBuildContext, 'wedaRoot'>;
    weapps: IWeAppData[];
    calses: IPlatformApp[];
    plugins: IPlugin[];
    deployOptions: Required<IBuildWedaApp>['deployOptions'];
    options: {
        mpAppId: string;
        resourceAppId?: string;
        isCrossAccount: boolean;
    };
    buildTypeList: BuildType[];
    ignoreInstall: boolean;
    cdnEndpoints?: ICDN_ENDPOINTS_COFIG;
    mpConfig?: IBuildWedaApp['mpConfig'];
}): Promise<{
    miniprogramRoot: string;
}>;
export declare function generateConfig(data: {
    domain?: string;
    isPrivateMode?: boolean;
    endpointType?: IBuildContext['endpointType'] | '';
}, root: string): Promise<void>;
export declare function writeLowCodeFiles(ctx: IBuildContext, appData: IWeAppData, outDir: string, cssVarMap?: CSSProperties): Promise<void>;
