import { IWeAppData } from '@cloudbase/lowcode-generator/lib/weapps-core';
import { IBuildContext } from './BuildContext';
import { IBuildWedaApp } from '../core';
import { IPlatformApp } from '@cloudbase/cals';
/**
 * generate app.json & page.json for mp
 *
 * @param kboneConfig https://wechat-miniprogram.github.io/kbone/docs/config/
 * @param appConfigs app config from prop edit panel
 */
export declare function generateMpConfig(ctx: Omit<IBuildContext, 'wedaRoot'>, weapps: IWeAppData[], calses: IPlatformApp[], options: {
    mpAppId?: string;
    mpConfig?: IBuildWedaApp['mpConfig'];
}): Promise<{
    projConfig: any;
    appConfig: any;
    pageConfigs: {}[];
}>;
interface ISubpackage {
    root: string;
    pages?: string[];
    plugins?: Record<string, {
        version?: string;
        provider?: string;
    }>;
}
export declare function mergeSubPackages(base?: ISubpackage[], extra?: ISubpackage[]): ISubpackage[];
export declare function mergePackNpmRelationList(base?: {
    packageJsonPath: string;
    miniprogramNpmDistDir: string;
}[], extra?: {
    packageJsonPath: string;
    miniprogramNpmDistDir: string;
}[]): {
    packageJsonPath: string;
    miniprogramNpmDistDir: string;
}[];
export declare function generateSystemPackNpmRelationList(wedaRootProjectPath: any): {
    packageJsonPath: string;
    miniprogramNpmDistDir: any;
}[];
export {};
