"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFilePath = exports.not = exports.is = void 0;
const ignoreList = [
    // # All
    '^npm-debug\\.log$',
    '^\\..*\\.swp$',
    // # macOS
    '^\\.DS_Store$',
    '^\\.AppleDouble$',
    '^\\.LSOverride$',
    '^Icon\\r$',
    '^\\._.*',
    '^\\.Spotlight-V100(?:$|\\/)',
    '\\.Trashes',
    '^__MACOSX$',
    // # Linux
    '~$',
    // # Windows
    '^Thumbs\\.db$',
    '^ehthumbs\\.db$',
    '^Desktop\\.ini$',
    '@eaDir$',
    '^.gitignore$',
    '^readme.md$',
    '^README.md$',
];
const filePathIgnoreList = [
    '__MACOSX', // 路径有__MACOSX就过滤
];
const regex = new RegExp(ignoreList.join('|'));
const filePathRegex = new RegExp(filePathIgnoreList.join('|'));
const is = (filename) => regex.test(filename);
exports.is = is;
const not = (filename) => !(0, exports.is)(filename);
exports.not = not;
const isFilePath = (filename) => filePathRegex.test(filename);
exports.isFilePath = isFilePath;
