import { IBuildWedaApp } from '../core';
export declare function downloadFile(url: string, filePath: string): Promise<void>;
/**
 * Download zip file and extract to dstDir
 * @param url
 * @param dstDir folder to hold the extract zip content
 */
export declare function downloadZip(url: string, dstDir: string, isBrowser?: boolean, noCache?: boolean): Promise<void>;
/**
 * node中下载和保存zip文件
 * @param url 下载的url
 * @param dstDir 存放文件夹
 */
export declare function downloadZipInNode(url: string, dstDir: string): Promise<void>;
/**
 * 浏览器中下载和保存zip文件
 * @param url 下载的url
 * @param dstDir 存放文件夹
 * @returns
 */
export declare function downloadZipInBrowser(url: string, dstDir: string, noCache: boolean): Promise<void>;
/**
 * 微信IDE builder需要下载template文件和miniprogram_npm
 * miniprogram_npm待微信提供端能力
 * @param output
 */
export declare function downloadBrowserMaterial({ runtimeEndpointType, browser, }: {
    runtimeEndpointType: IBuildWedaApp['endpointType'];
    browser?: boolean;
}): Promise<void>;
export declare function installBrowserDependencies({ type, path: outPath, runtimeEndpointType, }: {
    type: 'wedaRoot' | '$weda_system';
    path: string;
    runtimeEndpointType: IBuildWedaApp['endpointType'];
}): Promise<void>;
